#include <windows.h>
#include "letadla.cpp"

#define ID_LIST     1
#define ID_TEXT     2

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
LRESULT CALLBACK ListProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK NovyDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK ZmenDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK NumDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK PocetDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK ZpozdiDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK KamDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK OdletDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK BranaDlgProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL    CALLBACK AboutDlgProc (HWND, UINT, WPARAM, LPARAM) ;
void    save(HWND hwnd,char *szFile);
void    load(HWND hwnd,char *szFile);
void    klop(HDC hdc,int i,int num1, int num2, int num3, int num4, int num5);

WNDPROC OldList;
HWND  hwndList;
HINSTANCE hInst;
tabule odlet(9);
zaznam novy;
PARRAY pole;
int iPole, cxChar, cyChar;
bool hled;
bool saving;
bool preklop[9];

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static TCHAR szAppName[] = TEXT ("Tabule") ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;

     // uchovani pro pozdejsi pouziti
     hInst= hInstance;

     // naplneni struktury pro registrovani tridy
     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
//     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hIcon         = LoadIcon (hInstance, MAKEINTRESOURCE (150));
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
     wndclass.lpszMenuName  = szAppName ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Tento program vyaduje Windows NT!"),
                      szAppName, MB_ICONERROR) ;
          return 0 ;
     }

     // stvorime okno
     hwnd = CreateWindow (szAppName, TEXT ("Odletov tabule"),
                          WS_CAPTION |WS_SYSMENU |WS_MINIMIZEBOX,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          800, 300, NULL, NULL, hInstance, NULL) ;

     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

     saving= false;
     // smycka zprav
     while (GetMessage (&msg, NULL, 0, 0))
     {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
     }
     return msg.wParam ;
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
// cxChar, cyChar - rozmery znaku, num - cislo vybraneho letu
     static int   num ;
// seznam zobrazovanych zaznamu
     static zaznam *ukaz[9];
// struktura pro ulozeni tabule na disk
     static TCHAR szFileName[MAX_PATH], szTitleName[MAX_PATH] ;
// pomocne promenne
     char 			szBuffer[80] ;
     RECT         rc;
     int          iIndex, iPocet, num1, num2, num3, num4, num5;
     HDC          hdc ;
     PAINTSTRUCT  ps ;
     zaznam       *akt;
     SYSTEMTIME   st ;

     switch (message)
     {
     case WM_CREATE :
// napln promenne
          cxChar = LOWORD (GetDialogBaseUnits ()) ;
          cyChar = HIWORD (GetDialogBaseUnits ()) ;

// Vytvorime okno seznamu nalezenych letu

          hwndList = CreateWindow (TEXT ("listbox"), NULL,
                              WS_CHILD | WS_VISIBLE | LBS_STANDARD,
                              88*cxChar, cyChar * 2,
                              cxChar * 9 + GetSystemMetrics (SM_CXVSCROLL),
                              cyChar * 10, hwnd, (HMENU) ID_LIST,
                              (HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE),
                              NULL) ;

// nova procedura pro obsluhu seznamu
          OldList = (WNDPROC) SetWindowLong (hwndList, GWL_WNDPROC,
          							(LPARAM) ListProc) ;

// vytvor tlacitka
          CreateWindow ( TEXT("button"), "Novy",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 301, hInst, NULL) ;
          CreateWindow ( TEXT("button"), "Zmen",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar*15, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 302, hInst, NULL) ;
          CreateWindow ( TEXT("button"), "Smaz",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar*29, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 304, hInst, NULL) ;
          CreateWindow ( TEXT("button"), "Ukaz",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar*43, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 303, hInst, NULL) ;
          CreateWindow ( TEXT("button"), "Vypis",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar*57, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 401, hInst, NULL) ;
          CreateWindow ( TEXT("button"), "Tabule",
               WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, cxChar*71, cyChar * 14,
               10 * cxChar, 7 * cyChar / 4, hwnd, (HMENU) 402, hInst, NULL) ;

// inicializuj promenne
          for(iIndex=0;iIndex<10;iIndex++) {
            ukaz[iIndex]=NULL;
            preklop[iIndex]= true;
          }
          hled=FALSE;
          pole= NULL;
          szFileName[0]= '\0';
          szTitleName[0]= '\0';

// spust timer
          SetTimer (hwnd, 1, 1000, NULL) ;
          SetTimer (hwnd, 2, 300000, NULL) ; // zaloha po 5 minutach
          return 0 ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case ID_LIST:
// je vybrana polozka v seznamu hledani -> ukaz ji
             if(HIWORD (wParam) == LBN_SELCHANGE) {
               iIndex  = SendMessage (hwndList, LB_GETCURSEL, 0, 0) ;
               SendMessage (hwndList, LB_GETTEXT, iIndex, (LPARAM) szBuffer) ;
               num= atoi(szBuffer);
               return 0 ;
            }
            break;
// soubor -> novy
          case 101:
               if(IDYES==MessageBox(hwnd,"Opravdu smazat vsechny lety?","Varovani",MB_YESNO))
                     odlet.smazvse();
               return 0;
// soubor -> otevri
          case 102:
               load(hwnd,szFileName);
//               odlet.nahraj("tab.tab");
               return 0;
// soubor -> uloz
           case 103:
               save(hwnd,szFileName);
//               odlet.uloz("tab.tab");
               return 0 ;
// soubor -> konec
          case 104:
               SendMessage (hwnd, WM_CLOSE, 0, 0) ;
               return 0 ;
// soubor -> nastav pocet
          case 105:
               DialogBox(hInst, TEXT("PocetDlg"), hwnd, PocetDlgProc);
               return 0;
// hledej -> kam
          case 202:
          	   iPole=0;
					// smaz seznam
               SendMessage (hwndList, LB_RESETCONTENT, 0, 0) ;
               // napln pole dle uzivatele
               DialogBox(hInst, TEXT("KamDlg"), hwnd, KamDlgProc);
               // zapis nalezene do seznamu
               for(iIndex=0;iIndex<iPole;iIndex++)
                    SendMessage (hwndList, LB_ADDSTRING, 0,
                            (LPARAM) itoa(pole[iIndex],szBuffer,10)) ;
               free(pole);
               return 0;
// hledej -> odlet
          case 203:
          	   iPole=0;
               // smaz seznam
               SendMessage (hwndList, LB_RESETCONTENT, 0, 0) ;
               // napln pole dle uzivatele
               DialogBox(hInst, TEXT("OdletDlg"), hwnd, OdletDlgProc);
               // zapis nalezene do seznamu
               for(iIndex=0;iIndex<iPole;iIndex++)
                    SendMessage (hwndList, LB_ADDSTRING, 0,
                            (LPARAM) itoa(pole[iIndex],szBuffer,10)) ;
               free(pole);
               return 0;
// hledej -> brama
          case 204:
          	   iPole=0;
               // smaz seznam
               SendMessage (hwndList, LB_RESETCONTENT, 0, 0) ;
               // napln pole dle uzivatele
               DialogBox(hInst, TEXT("BranaDlg"), hwnd, BranaDlgProc);
               // zapis nalezene do seznamu
               for(iIndex=0;iIndex<iPole;iIndex++)
                    SendMessage (hwndList, LB_ADDSTRING, 0,
                            (LPARAM) itoa(pole[iIndex],szBuffer,10)) ;
               free(pole);
               return 0;
// hledej -> zpozdeni
          case 205:
               // smaz seznam
               SendMessage (hwndList, LB_RESETCONTENT, 0, 0) ;
               // napln pole zpozdenymi lety
               iPole=odlet.najdi(&pole);
               // prepis do seznamu
               for(iIndex=0;iIndex<iPole;iIndex++)
                    SendMessage (hwndList, LB_ADDSTRING, 0,
                            (LPARAM) itoa(pole[iIndex],szBuffer,10)) ;
               free(pole);
               return 0;
// let -> novy
          case 301:
               DialogBox (hInst, TEXT ("NovyDlg"), hwnd, NovyDlgProc);
               return 0;
// let -> zmen
          case 302:
          	   novy.num=0;
               // zeptej se na cislo letu
               DialogBox(hInst, TEXT("NumDlg"), hwnd, NumDlgProc);
               // uzivatel zadal?
               if(novy.num > 0)
                      DialogBox (hInst, TEXT ("ZmenDlg"), hwnd, ZmenDlgProc);
               return 0;
// let -> ukaz
          case 303:
          	   novy.num=0;
               // zeptej se na cislo letu
               DialogBox(hInst, TEXT("NumDlg"), hwnd, NumDlgProc);
               // pokud uzivatel zadal, ukaz ho
               if(novy.num > 0)
                   num=novy.num;
               return 0;
// let -> smaz
          case 304:
               novy.num=0;
               // zeptej se na cislo letu
               DialogBox(hInst, TEXT("NumDlg"), hwnd, NumDlgProc);
               // pokud uzivatel zadal
               if(novy.num>0)
                      odlet.vyjmi(novy.num);
               return 0;
// let -> zpozdi
          case 305:
               DialogBox(hInst, TEXT("ZpozdiDlg"), hwnd, ZpozdiDlgProc);
               return 0;
// tlacitko vypis hledani
          case 401:
               // pokud je co
               if((iPocet=SendMessage (hwndList, LB_GETCOUNT, 0, 0))>0) {
                   // nastav, ze chceme vyber z okna
                   hled=TRUE;
                   // zacni prepisovat
                   for(iIndex=0;iIndex<10;iIndex++)
                     if(iIndex<iPocet) {
                        // ziskej cislo letu ze seznamu
                        SendMessage (hwndList, LB_GETTEXT, iIndex,
                             (LPARAM) szBuffer) ;
                        // zapis do seznamu ukazovanych letu
                        akt=odlet.get(atoi(szBuffer));
                        if(!ukaz[iIndex]) {
                          ukaz[iIndex]=akt;
                          preklop[iIndex]=true;
                        }
                        else if(akt && (ukaz[iIndex]->num != akt->num)) {
                          ukaz[iIndex]=akt;
                          preklop[iIndex]=true;
                        }
                        else
                          preklop[iIndex]=false;
                     }
                     else {
                        ukaz[iIndex]=NULL;
                        preklop[iIndex]= false;
                     }
               }
               else
                   MessageBox(hwnd,"Seznam hledani je prazdny","Varovani",MB_OK);
               return 0;
// tlacitko vypisovani zacatku tabule
          case 402:
               hled=FALSE;
               return 0;
// about
          case 901:
               DialogBox(hInst, TEXT("AboutDlg"), hwnd, AboutDlgProc);
               return 0;
// tohle by nemelo nastat
          default:
               MessageBeep(0);
          }
          break;

// casovac dal zpravu
     case WM_TIMER :
          // po peti minutach udelej zalohu
          if(wParam==2) {
             if(!odlet.uloz("tab.bak"))
                  MessageBox(hwnd,"Nepovedla se ulozit zaloha","Chyba",MB_OK);
          }
          // kazdou vterinu:
          // aktualizuj odlety
          do {
             // ukaz na prvni
             akt= odlet.getbypos(1);
             if(akt==NULL)
               break;
             // zjisti cas
             GetLocalTime (&st) ;
             // vypocti odlety
             iPocet= akt->zpozdeni + akt->odlet.minuta + 60*akt->odlet.hodina + 60*24*akt->odlet.den + 60*24*31*akt->odlet.mesic + 60*24*31*12*akt->odlet.rok;
             iIndex= st.wMinute + 60*st.wHour + 60*24*st.wDay+ 60*24*31*st.wMonth + 60*24*31*12*st.wYear;
             // ma odletet?
             if(iPocet < iIndex) {
                 // odelta normalni let
                 if(akt->zpozdeni==0)
                    wsprintf(szBuffer,"Prave odetel let %d do %s z brany %d",
                      akt->num,akt->kam,akt->brana);
                 // odeleta zpozdeny let
                  else
                    wsprintf(szBuffer,"Prave odetel zpozdeny let %d do %s z brany %d",
                      akt->num,akt->kam,akt->brana);
                 // vyjmi ze seznamu
                 odlet.vyjmi(akt->num);
                 MessageBox(hwnd,szBuffer,"Hlaseni",MB_OK);
             }
          } while(iPocet < iIndex);
          // mam vypisovat zacatek seznamu tabule?
          if(!hled) {
            // uloz do pole zacatek tabule
            iPocet= odlet.vypis(&pole);
            // prepis do seznamu ukazovanych letu
            for(iIndex=0;iIndex<10;iIndex++) {
               if(iIndex<iPocet) {
                  akt=odlet.get(pole[iIndex]);
                  if(!ukaz[iIndex]) {
                    ukaz[iIndex]=akt;
                    preklop[iIndex]=true;
                  }
                  else if(akt && (ukaz[iIndex]->num != akt->num)) {
                    ukaz[iIndex]=akt;
                    preklop[iIndex]=true;
                  }
                  else
                    preklop[iIndex]=false;
               }
               else {
                  ukaz[iIndex]=NULL;
                  preklop[iIndex]=false;
               }
            }
            free(pole);
          }
          // aktualizuj obrazovku
          InvalidateRect (hwnd, NULL, FALSE) ;
          return 0;

// mame malovat
     case WM_PAINT :
          // ziskej handle na plochu
          hdc = BeginPaint (hwnd, &ps) ;
          // pokud pracuje se souborem -> pryc
          if(saving) {
            EndPaint(hwnd,&ps);
            return 0;
          }
          // ziskej a vymaz celou plochu
          GetClientRect (hwnd, &rc) ;
          Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom);
          // ramecek
          Rectangle(hdc, cxChar, cyChar, cxChar*86, cyChar*11);

          // lajny
          MoveToEx(hdc,6*cxChar+cxChar/2,cyChar,NULL);
          LineTo(hdc,6*cxChar+cxChar/2,11*cyChar);
          MoveToEx(hdc,12*cxChar,cyChar,NULL);
          LineTo(hdc,12*cxChar,11*cyChar);
          MoveToEx(hdc,56*cxChar+cxChar/2,cyChar,NULL);
          LineTo(hdc,56*cxChar+cxChar/2,11*cyChar);
          MoveToEx(hdc,72*cxChar+cxChar/2,cyChar,NULL);
          LineTo(hdc,72*cxChar+cxChar/2,11*cyChar);
          MoveToEx(hdc,81*cxChar,cyChar,NULL);
          LineTo(hdc,81*cxChar,11*cyChar);
          MoveToEx(hdc,cxChar,2*cyChar,NULL);
          LineTo(hdc,86*cxChar,2*cyChar);

          SetBkMode(hdc, TRANSPARENT);

          // popisky
			 TextOut(hdc, 88*cxChar, cyChar,"Vys.hledani:",12);
			 TextOut(hdc, cxChar, cyChar,"Poradi",6);
			 TextOut(hdc, 7*cxChar, cyChar,"C.letu",6);
			 TextOut(hdc, 12*cxChar, cyChar,"Kam",3);
			 TextOut(hdc, 57*cxChar, cyChar,"Odlet",5);
			 TextOut(hdc, 73*cxChar, cyChar,"Zpozdeni",8);
 			 TextOut(hdc, 81*cxChar, cyChar,"Brana",5);

 			 TextOut(hdc, 3*cxChar, 2*cyChar,"1",1);
 			 TextOut(hdc, 3*cxChar, 3*cyChar,"2",1);
 			 TextOut(hdc, 3*cxChar, 4*cyChar,"3",1);
 			 TextOut(hdc, 3*cxChar, 5*cyChar,"4",1);
 			 TextOut(hdc, 3*cxChar, 6*cyChar,"5",1);
 			 TextOut(hdc, 3*cxChar, 7*cyChar,"6",1);
 			 TextOut(hdc, 3*cxChar, 8*cyChar,"7",1);
 			 TextOut(hdc, 3*cxChar, 9*cyChar,"8",1);
 			 TextOut(hdc, 3*cxChar, 10*cyChar,"9",1);

          // vypis lety v seznamu ukazovanych
          for(iIndex=0;iIndex<10;iIndex++)
            if(ukaz[iIndex]!=NULL) {
              if(preklop[iIndex]) {
                preklop[iIndex]=false;
                num1=wsprintf(szBuffer,"%d",ukaz[iIndex]->num);
                num2=wsprintf(szBuffer,"%s",ukaz[iIndex]->kam);
                num3=wsprintf(szBuffer,"%d.%d.%d %02d:%02d",
                     ukaz[iIndex]->odlet.den, ukaz[iIndex]->odlet.mesic,
                     ukaz[iIndex]->odlet.rok, ukaz[iIndex]->odlet.hodina,
                     ukaz[iIndex]->odlet.minuta);
                num4=wsprintf(szBuffer,"%d",ukaz[iIndex]->zpozdeni);
                num5=wsprintf(szBuffer,"%d",ukaz[iIndex]->brana);
                klop(hdc,iIndex,num1, num2, num3, num4, num5);
              }
              iPocet=wsprintf(szBuffer,"%d",ukaz[iIndex]->num);
              TextOut(hdc,7*cxChar,(2+iIndex)*cyChar,szBuffer,iPocet);
              iPocet=wsprintf(szBuffer,"%s",ukaz[iIndex]->kam);
              TextOut(hdc,12*cxChar,(2+iIndex)*cyChar,szBuffer,iPocet);
              iPocet=wsprintf(szBuffer,"%d.%d.%d %02d:%02d",
                     ukaz[iIndex]->odlet.den, ukaz[iIndex]->odlet.mesic,
                     ukaz[iIndex]->odlet.rok, ukaz[iIndex]->odlet.hodina,
                     ukaz[iIndex]->odlet.minuta);
              TextOut(hdc,57*cxChar,(2+iIndex)*cyChar,szBuffer,iPocet);
              iPocet=wsprintf(szBuffer,"%d",ukaz[iIndex]->zpozdeni);
              TextOut(hdc,73*cxChar,(2+iIndex)*cyChar,szBuffer,iPocet);
              iPocet=wsprintf(szBuffer,"%d",ukaz[iIndex]->brana);
              TextOut(hdc,81*cxChar,(2+iIndex)*cyChar,szBuffer,iPocet);
            }

          // vypis vybrany let
 			 TextOut(hdc, cxChar, 12*cyChar,"Vybrany:",8);
          akt=odlet.get(num);
          if(akt!=NULL) {
      			 TextOut(hdc, 9*cxChar, 12*cyChar,szBuffer,wsprintf(szBuffer,
                "%d %s %d.%d.%d %02d:%02d %d %d",
                akt->num,akt->kam,akt->odlet.den,
                akt->odlet.mesic,akt->odlet.rok,akt->odlet.hodina,
                akt->odlet.minuta,akt->zpozdeni,akt->brana));
          }

          // vypis cas
          GetLocalTime (&st) ;
          TextOut(hdc,83*cxChar,14*cyChar+cyChar/2,szBuffer,wsprintf(szBuffer,
              "%d.%d %d %02d:%02d:%02d",st.wDay,st.wMonth,st.wYear,st.wHour,
              st.wMinute,st.wSecond));
              
          // konec malovani
          EndPaint (hwnd, &ps) ;
          return 0;

// chceme skoncit?
     case WM_CLOSE :
          if (IDYES == MessageBox(hwnd,"Opravdu ukoncit?", "Tabule",
          				MB_YESNO | MB_ICONQUESTION ))
               DestroyWindow (hwnd) ;

          return 0 ;

// nekdo nas nasilne ukoncuje
     case WM_QUERYENDSESSION :
          if (IDYES == MessageBox(hwnd,"Opravdu ukoncit?", "Tabule",
          				MB_YESNO | MB_ICONQUESTION))
               return 1 ;

          return 0 ;

// tak skonci
     case WM_DESTROY :
          // uklid po sobe
          KillTimer(hwnd,1);
          PostQuitMessage (0) ;
          return 0 ;
     }
     return DefWindowProc (hwnd, message, wParam, lParam) ;
}

// nova procedura pro Listbox, pridavajici nektere funkce
LRESULT CALLBACK ListProc (HWND hwnd, UINT message,
                           WPARAM wParam, LPARAM lParam)
{
/*     if (message == WM_KEYDOWN && wParam == VK_RETURN)
          SendMessage (GetParent (hwnd), WM_COMMAND,
                       MAKELONG (1, LBN_DBLCLK), (LPARAM) hwnd) ;
*/
     // zmackli jsme delete?
     if (message == WM_KEYDOWN && wParam == VK_DELETE)
          // smaz vybranou polozku
          SendMessage (hwndList, LB_DELETESTRING, SendMessage (hwndList,
                       LB_GETCURSEL, 0, 0), 0) ;

     // stara procedura
     return CallWindowProc (OldList, hwnd, message, wParam, lParam) ;
}

// procedura obsluhujici dialog noveho letu
BOOL CALLBACK NovyDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char szBuffer[40];
     SYSTEMTIME   st ;
     int iPocet, iIndex;

     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          // tlacitko OK
          case IDOK :
          	   // napln novy zadanyma udajema
               GetDlgItemText(hDlg,110,szBuffer,6);
               novy.num= atoi(szBuffer);
               if(novy.num < 1) {
                    MessageBox(hDlg,"Spatne cislo letu","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,111,szBuffer,39);
               strcpy(novy.kam, szBuffer);

               GetDlgItemText(hDlg,112,szBuffer,5);
               novy.odlet.rok= atoi(szBuffer);
               if(novy.odlet.rok < 1) {
                    MessageBox(hDlg,"Spatny rok","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,113,szBuffer,3);
               novy.odlet.mesic= atoi(szBuffer);
               if((novy.odlet.mesic < 1)|| (novy.odlet.mesic > 12)) {
                    MessageBox(hDlg,"Spatny mesic","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,114,szBuffer,3);
               novy.odlet.den= atoi(szBuffer);
               if((novy.odlet.den < 1) || (novy.odlet.den > 31)) {
                    MessageBox(hDlg,"Spatny den","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,115,szBuffer,3);
               novy.odlet.hodina= atoi(szBuffer);
               if((novy.odlet.hodina < 0) || (novy.odlet.hodina > 23)) {
                    MessageBox(hDlg,"Spatna hodina","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,116,szBuffer,3);
               novy.odlet.minuta= atoi(szBuffer);
               if((novy.odlet.minuta < 0) || (novy.odlet.minuta > 59)) {
                    MessageBox(hDlg,"Spatna minuta","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,117,szBuffer,5);
               novy.zpozdeni= atoi(szBuffer);
               if(novy.zpozdeni < 0) {
                    MessageBox(hDlg,"Zpozdeni nemuze byt zaporne","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,118,szBuffer,5);
               novy.brana= atoi(szBuffer);
               if(novy.brana < 0) {
                    MessageBox(hDlg,"Brana nemuze byt zaporna","Chyba",MB_OK);
                    return FALSE;
               }

               GetLocalTime (&st) ;
               iPocet= novy.zpozdeni + novy.odlet.minuta + 60*novy.odlet.hodina + 60*24*novy.odlet.den + 60*24*31*novy.odlet.mesic + 60*24*31*12*novy.odlet.rok;
               iIndex= st.wMinute + 60*st.wHour + 60*24*st.wDay+ 60*24*31*st.wMonth + 60*24*31*12*st.wYear;
               if(iPocet<iIndex) {
                    if(IDYES==MessageBox(hDlg,"Tento let uz mel odeletet!\nPresto zaradit do tabule?","Otazka",MB_YESNO)) {
                      if(!odlet.vloz(novy)) {
                        MessageBox(hDlg,"Chyba pri ukladani do tabule - cislo letu uz bylo nejspise pouzito","Chyba",MB_OK);
                        return FALSE;
                      }
                      EndDialog (hDlg, 0) ;
                      return TRUE ;
                    }
                    else
                      return FALSE;
               }         

               // vloz novy do tabule
               if(!odlet.vloz(novy)) {
                    MessageBox(hDlg,"Chyba pri ukladani do tabule - cislo letu uz bylo nejspise pouzito","Chyba",MB_OK);
                    return FALSE;
               }

               // skonci dialog
               EndDialog (hDlg, 0) ;
               return TRUE ;
          // tlacitko CANCEL
          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura pro zmen dialog
BOOL CALLBACK ZmenDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char szBuffer[40];

     switch (message)
     {
     case WM_INITDIALOG :
     	    // vybrany let v tabuli neni
          if(!odlet.get(novy.num)) {
               EndDialog (hDlg, 0);
               return TRUE ;
          }
          // ziskej let a ukaz udaje v dialogu
          novy= *odlet.get(novy.num);

          SetWindowText(GetDlgItem(hDlg,120),itoa(novy.num,szBuffer,10));
          SetDlgItemText(hDlg,111,novy.kam);
          SetDlgItemText(hDlg,112,itoa(novy.odlet.rok,szBuffer,10));
          SetDlgItemText(hDlg,113,itoa(novy.odlet.mesic,szBuffer,10));
          SetDlgItemText(hDlg,114,itoa(novy.odlet.den,szBuffer,10));
          SetDlgItemText(hDlg,115,itoa(novy.odlet.hodina,szBuffer,10));
          SetDlgItemText(hDlg,116,itoa(novy.odlet.minuta,szBuffer,10));
          SetDlgItemText(hDlg,117,itoa(novy.zpozdeni,szBuffer,10));
          SetDlgItemText(hDlg,118,itoa(novy.brana,szBuffer,10));
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
               // napln novy zadanymi udajemi
               GetDlgItemText(hDlg,111,szBuffer,39);
               strcpy(novy.kam, szBuffer);

               GetDlgItemText(hDlg,112,szBuffer,5);
               novy.odlet.rok= atoi(szBuffer);
               if(novy.odlet.rok < 1) {
                    MessageBox(hDlg,"Spatny rok","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,113,szBuffer,3);
               novy.odlet.mesic= atoi(szBuffer);
               if((novy.odlet.mesic < 1)|| (novy.odlet.mesic > 12)) {
                    MessageBox(hDlg,"Spatny mesic","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,114,szBuffer,3);
               novy.odlet.den= atoi(szBuffer);
               if((novy.odlet.den < 1) || (novy.odlet.den > 31)) {
                    MessageBox(hDlg,"Spatny den","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,115,szBuffer,3);
               novy.odlet.hodina= atoi(szBuffer);
               if((novy.odlet.hodina < 0) || (novy.odlet.hodina > 23)) {
                    MessageBox(hDlg,"Spatna hodina","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,116,szBuffer,3);
               novy.odlet.minuta= atoi(szBuffer);
               if((novy.odlet.minuta < 0) || (novy.odlet.minuta > 59)) {
                    MessageBox(hDlg,"Spatna minuta","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,117,szBuffer,5);
               novy.zpozdeni= atoi(szBuffer);
               if(novy.zpozdeni < 0) {
                    MessageBox(hDlg,"Zpozdeni nemuze byt zaporne","Chyba",MB_OK);
                    return FALSE;
               }

               GetDlgItemText(hDlg,118,szBuffer,5);
               novy.brana= atoi(szBuffer);
               if(novy.brana < 0) {
                    MessageBox(hDlg,"Brana nemuze byt zaporna","Chyba",MB_OK);
                    return FALSE;
               }

               // zmen dany let v tabuli
               odlet.zmen(novy);

               EndDialog (hDlg, 0) ;
               return TRUE ;
          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura pro dialog zadavani cisla letu
BOOL CALLBACK NumDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char szBuffer[40];

     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
          	   // ziskej cislo letu
               GetDlgItemText(hDlg,119,szBuffer,6);
               novy.num= atoi(szBuffer);
               // je platne?
               if(novy.num < 1)
						return FALSE;
               EndDialog (hDlg, 0) ;
               return TRUE ;

          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura dialogu pro nastaveni poctu zobrazovanych letu
BOOL CALLBACK PocetDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     int   pocet;
     char  szBuffer[2];
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
          	   // ziskej pocet
               GetDlgItemText(hDlg,110,szBuffer,2);
               pocet= atoi(szBuffer);
               if((pocet < 1) || (pocet >9)) {
                  MessageBox(hDlg,"Pocet je prilis maly nebo velky","Chyba",
                      MB_OK);
						return FALSE;
               }
               EndDialog (hDlg, 0) ;
               return TRUE ;

          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura dialogu pro zpozdovani letu
BOOL CALLBACK ZpozdiDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     int   pocet,let;
     char  szBuffer[7];
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case EN_KILLFOCUS:
               // zadali jsme cislo letu
               if(LOWORD(wParam)==110) {
                   // precti cislo letu
                   GetDlgItemText(hDlg,110,szBuffer,6);
                   let= atoi(szBuffer);
                   if(!odlet.get(let)) {
                        MessageBox(hDlg,"Takovy let neexistuje","Chyba",MB_OK);
                        return TRUE ;
                   }
                   // ukaz zpozdeni
                   novy= *odlet.get(let);
                   SetWindowText(GetDlgItem(hDlg,111),itoa(novy.zpozdeni,szBuffer,10));
               }
               return 0;
          case IDOK :
               // precti let a zpozdeni
               GetDlgItemText(hDlg,110,szBuffer,6);
               let= atoi(szBuffer);
               if(let < 1) {
                  MessageBox(hDlg,"Spatny let","Chyba",MB_OK);
						return FALSE;
               }
               GetDlgItemText(hDlg,112,szBuffer,5);
               pocet= atoi(szBuffer);
               if(pocet < 0) {
                  MessageBox(hDlg,"Zpozdeni nemuze byt zaporne","Chyba",MB_OK);
						return FALSE;
               }

               // nastav nove udaje
               odlet.zpozdi(let,pocet);

               EndDialog (hDlg, 0) ;
               return TRUE ;

          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura dialogu hledani kam
BOOL CALLBACK KamDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char  szBuffer[40];
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
               // zjisti co hledame
               GetDlgItemText(hDlg,110,szBuffer,39);
               // a najdi to
               iPole= odlet.najdi(&pole,szBuffer);
               EndDialog (hDlg, 0) ;
               return TRUE ;

          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura dialogu hledani casu odletu
BOOL CALLBACK OdletDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char szBuffer[6];
     cas  time;

     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
               // precti pozadovany cas odletu
               GetDlgItemText(hDlg,110,szBuffer,5);
               time.rok= atoi(szBuffer);

               GetDlgItemText(hDlg,111,szBuffer,3);
               time.mesic= atoi(szBuffer);

               GetDlgItemText(hDlg,112,szBuffer,3);
               time.den= atoi(szBuffer);

               GetDlgItemText(hDlg,113,szBuffer,3);
               time.hodina= atoi(szBuffer);

               GetDlgItemText(hDlg,114,szBuffer,3);
               time.minuta= atoi(szBuffer);

               // najdi odpovidajici lety
               iPole= odlet.najdi(&pole,time);

               EndDialog (hDlg, 0) ;
               return TRUE ;
          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura dialogu pro hledani brany
BOOL CALLBACK BranaDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     char  szBuffer[6];
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
               // precti pozadovanou branu
               GetDlgItemText(hDlg,110,szBuffer,5);
               // najdi odpovidajci lety
               iPole= odlet.najdi(&pole,atoi(szBuffer));
               EndDialog (hDlg, 0) ;
               return TRUE ;

          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

// procedura about dialogu
BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;

     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK :
          case IDCANCEL :
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}


void load(HWND hwnd,char *szFile) {
  OPENFILENAME ofn;       // common dialog box structure
  HANDLE hf;              // file handle
  zaznam z;
  unsigned long *number;
  char szBuffer[MAX_PATH];

  saving=true;
// Initialize OPENFILENAME
  ZeroMemory(&ofn, sizeof(ofn));
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = hwnd;
  ofn.lpstrFile = szFile;
  ofn.nMaxFile = MAX_PATH;
  ofn.lpstrFilter = "Tabule\0*.tab\0All\0*.*\0";
  ofn.nFilterIndex = 1;
  ofn.lpstrFileTitle = NULL;
  ofn.nMaxFileTitle = 0;
  ofn.lpstrInitialDir = NULL;
  ofn.Flags = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;

  number= (unsigned long *)malloc(sizeof(unsigned long *));

// Display the Open dialog box.
  if(IDYES==MessageBox(hwnd,
    "Opravdu smazat vsechny lety a nahrat ze souboru?",
    "Varovani",MB_YESNO))
    if (GetOpenFileName(&ofn)==TRUE) {
        odlet.smazvse();
        odlet.nahraj(ofn.lpstrFile);
  }
  else {
    wsprintf(szBuffer,"Chyba pri otevirani %d",CommDlgExtendedError());
    MessageBox(hwnd,szBuffer,"chyba",MB_OK);
  }
  free(number);
  saving=false;
}

void save(HWND hwnd,char *szFile) {
  OPENFILENAME ofn;       // common dialog box structure
  HANDLE hf;              // file handle
  zaznam z;
  unsigned long *number;
  int i=1;
  char szBuffer[MAX_PATH];
  char *path;
  LPVOID lpMsgBuf;

  saving= true;
// Initialize OPENFILENAME
  ZeroMemory(&ofn, sizeof(ofn));
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = hwnd;
  ofn.lpstrFile = szFile;
  ofn.nMaxFile = MAX_PATH;
  ofn.lpstrFilter = "Tabule\0*.tab\0All\0*.*\0";
  ofn.nFilterIndex = 1;
  ofn.lpstrFileTitle = NULL;
  ofn.nMaxFileTitle = 0;
  ofn.lpstrInitialDir = NULL;
  ofn.Flags = OFN_OVERWRITEPROMPT | OFN_CREATEPROMPT;

// Display the Open dialog box.
  number= (unsigned long *)malloc(sizeof(unsigned long *));
  path= (char *)malloc(MAX_PATH*sizeof(char));

  if (GetSaveFileName(&ofn))
    odlet.uloz(ofn.lpstrFile);
  free(number);
  saving= false;
}

void klop(HDC hdc,int i,int num1, int num2, int num3, int num4, int num5) {
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+1);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+2);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+3);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+4);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+5);

  SelectObject (hdc, GetStockObject (WHITE_PEN)) ;
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+3);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+3);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+3,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+3);

  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+4);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+4);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+4,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+4);

  SelectObject (hdc, GetStockObject (BLACK_PEN)) ;
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+5);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+7);
  Sleep(30);
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,12*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(12+num2)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,81*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(81+num5)*cxChar,(2+i)*cyChar+9);
  Sleep(30);

  SelectObject (hdc, GetStockObject (WHITE_PEN)) ;
  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+1);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+1);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+1,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+1);

  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+2);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+2);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+2,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+2);

  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+5);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+5);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+5,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+5);

  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+7);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+7);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+7,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+7);

  MoveToEx(hdc,7*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(7+num1)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,12*cxChar+1,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(12+num2)*cxChar+1,(2+i)*cyChar+9);
  MoveToEx(hdc,57*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(57+num3)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,73*cxChar,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(73+num4)*cxChar,(2+i)*cyChar+9);
  MoveToEx(hdc,81*cxChar+1,(2+i)*cyChar+9,NULL);
  LineTo(hdc,(81+num5)*cxChar+1,(2+i)*cyChar+9);
  SelectObject (hdc, GetStockObject (BLACK_PEN)) ;
}
