#ifndef _LETADLA
#define _LETADLA

// struktura pro uchovani casoveho udaje ctime
typedef struct cas {
	int rok;
	int mesic;
	int den;
	int hodina;
	int minuta;
} cas;

// struktura pro ulozeni dat o jednotlivych letech
typedef struct zaznam {
 	int num;
  	char kam[40];
	cas odlet;
   int zpozdeni;
  	int brana;
   int priorita;
} zaznam;

// struktura pro vytvoreni spojoveho seznamu letu
typedef struct let {
 	zaznam data;
   let *dalsi;
} let;

// struktura pro vraceni seznamu letu
typedef int * PARRAY;

class tabule {
   public:

		tabule();  // konstruktor
		tabule(int p);  // konstruktor
//     tabule(tabule &t); // copy konstruktor
		~tabule();  // destruktor
		int vloz(zaznam z); // vloz dalsi zaznam o letu
		int zpozdi(int l,int cas); // spozdi let l o cas minut
		int zmen(zaznam z); // zmen let z.num na z
		zaznam *get(int l); // precti let l
		zaznam *getbypos(int pos); // precti pos. zaznam
		int vyjmi(int l); // vyjmi let l
		int najdi(PARRAY *pole,char *kam); // vraci seznam letu, ktere leti kam
		int najdi(PARRAY *pole,cas time); // vraci seznam letu odletajici v time
		int najdi(PARRAY *pole,int gate); // vraci seznam letu odletajici z brany gate
		int najdi(PARRAY *pole); // vraci seznam letu majici spozdeni
		int vypis(PARRAY *pole); // vypis seznam prvnich kolik letu
		int getpocet() {return kolik;}; // vrat pocet zobrazovanych zaznamu
		int setpocet(int p); // nastav pocet zobrazovanych zaznamu
		int smazvse(); // vymaze tabuli
      int uloz(char *name); // uloz tabuli do souboru
      int nahraj(char *name); // nahraj tabuli ze souboru

	private:

      let *prvni;  // prvni zaznam spojoveho seznamu
      int kolik;  // pocet zobrazovanych letu
};

#endif
